Attribute VB_Name = "Module1"
Const basechars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
Function InvokeWebService(strSoap, strSOAPAction, strURL, ByRef xmlResponse) As Boolean
Dim xmlhttp As MSXML2.XMLHTTP30
Dim blnSuccess As Boolean

Set xmlhttp = New MSXML2.XMLHTTP30
xmlhttp.open "POST", strURL, False
xmlhttp.setRequestHeader "Man", "POST " & strURL & " HTTP/1.1"
xmlhttp.setRequestHeader "Content-Type", "text/xml; charset=utf-8"
xmlhttp.setRequestHeader "SOAPAction", strSOAPAction
Call xmlhttp.send(strSoap)

If xmlhttp.Status = 200 Then
blnSuccess = True
Else
blnSuccess = False
End If

Set xmlResponse = xmlhttp.responseXML
Form1.resultado.Text = xmlhttp.responseText


InvokeWebService = blnSuccess

Set xmlhttp = Nothing
End Function
Function ReadBinData(ByVal strFileName As String) As String
    Dim lLen As Long
    Dim iFile As Integer
    Dim arrBytes() As Byte
    Dim lCount As Long
    Dim strOut As String
    
    iFile = FreeFile()
    Open strFileName For Binary Access Read As iFile
    lLen = FileLen(strFileName)
    ReDim arrBytes(lLen - 1)
    Get iFile, , arrBytes
    Close iFile
    
   ReadBinData = encodeBase64(arrBytes)
End Function
Private Function encodeBase64(ByRef arrData() As Byte) As String
    Dim objXML As MSXML2.DOMDocument
    Dim objNode As MSXML2.IXMLDOMElement
    
    Set objXML = New MSXML2.DOMDocument
    
    Set objNode = objXML.createElement("b64")
    objNode.dataType = "bin.base64"
    objNode.nodeTypedValue = arrData
    encodeBase64 = objNode.Text

    Set objNode = Nothing
    Set objXML = Nothing
End Function
Public Sub generaQR(cod As String, nombre As String, img As PictureBox)
Dim sBuffer As String
    sBuffer = sBuffer & DecodeFile(cod)
    SaveFile App.Path & "\QR\" & nombre, sBuffer
    fData = ""
    sBuffer = ""
    'img.Picture = LoadPicture(App.Path & "\QR\" & nombre)
    
    img.PaintPicture LoadPicture(App.Path & "\QR\" & nombre), 0, 0, img.ScaleWidth, img.ScaleHeight
    
    
End Sub
Private Sub SaveFile(lpFile As String, lpData As String)
Dim fp As Long
    fp = FreeFile
    Open lpFile For Output As #fp
        Print #fp, lpData;
    Close #fp
End Sub
Private Function RShift(ByVal pnValue As Double, ByVal pnShift As Double) As Double
    RShift = pnValue \ (2 ^ pnShift)
End Function
Private Function LShift(ByVal pnValue As Double, ByVal pnShift As Double) As Double
    LShift = pnValue * (2 ^ pnShift)
End Function
Function DecodeFile(LpStr As String) As String
On Error Resume Next
Dim StrA As String, StrB As String
Dim a As Integer, b As Integer, x As Integer, i As Long

    StrA = LpStr
    
    For i = 1 To Len(StrA)
        x = GetCharPos(basechars, Mid$(StrA, i, 1), 1) - 1
        
        If x >= 0 Then
            b = b * 64 + x
            a = a + 6
            If a >= 8 Then
                a = a - 8
                x = RShift(b, a)
                b = b Mod LShift(1, a)
                x = x Mod 256
                StrB = StrB & Chr(x)
            End If
        End If
    Next
    
    a = 0: b = 0: i = 0: x = 0
    DecodeFile = StrB
    StrA = "": StrB = ""
    
End Function
Public Function GetCharPos(LpStr As String, lFindChar As String, sPosition As Integer) As Integer
Dim e_Pos As Integer, x

    e_Pos = -1
    For x = 1 To Len(LpStr)
        If Mid(LpStr, x, 1) = lFindChar Then
            e_Pos = x
            If sPosition = 0 Then
                Exit For
            End If
        End If
    Next
    
    x = 0
    GetCharPos = e_Pos
    e_Pos = 0
    
End Function
Function limpia()
'limpia los campos
Form1.txtsdigital.Text = ""
Form1.txtcersat.Text = ""
Form1.txttimsan.Text = ""
Form1.txtfolsat.Text = ""
Form1.txtcodOr.Text = ""
Set Form1.qr.Picture = Nothing

Form1.txtsdigitalO.Text = ""
Form1.txtcersatO.Text = ""
Form1.txttimsanO.Text = ""
Form1.txtfolsatO.Text = ""
Form1.txtcodOrO.Text = ""
Set Form1.qrO.Picture = Nothing




End Function

